image: node:14.15-alpine

variables:
  DOCKER_DRIVER: overlay
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"
  GIT_DEPTH: "0"
  SWING_WEB_IMAGE_NAME: "registry.gitlab.com/fallguys/official/swing-client:web-${CI_COMMIT_BRANCH}-${CI_COMMIT_SHORT_SHA}"
  SWING_PROXY_IMAGE_NAME: "registry.gitlab.com/fallguys/official/swing-client:proxy-${CI_COMMIT_BRANCH}-${CI_COMMIT_SHORT_SHA}"


stages:
  - build
  - test
  - package
  - predeploy


node-build:
  stage: build
  script:
    - yarn install
  artifacts:
    untracked: false
    expire_in: 1h
    paths:
      - node_modules


unit-test:
  stage: test
  script:
    - yarn run test


inspect-sonar-feedback:
  stage: test
  image:
    name: sonarsource/sonar-scanner-cli:latest
    entrypoint: [""]
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - sonar-scanner
  only:
    - dev
    - staging
    - release
    - master
    - merge_requests


integration-test:
  stage: test
  script:
    - echo "running integration tests"
  only:
    - dev
    - staging
    - release
    - master


docker-registry-web:
  image: docker:latest
  stage: package
  services:
    - docker:dind
  before_script:
    - cat $WEB_CLIENT_ENV_FILE > .env
  script:
    - docker build -t $SWING_WEB_IMAGE_NAME .
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
    - docker push $SWING_WEB_IMAGE_NAME
  only:
    - staging
    - release


docker-registry-proxy:
  image: docker:latest
  stage: package
  services:
    - docker:dind
  script:
    - docker build -t $SWING_PROXY_IMAGE_NAME ./nginx
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
    - docker push $SWING_PROXY_IMAGE_NAME
  only:
    - staging
    - release


make-aws-ecs:
  stage: predeploy
  before_script:
    - apk update
    - apk add --no-cache jq
  script:
    - mkdir -p aws/deploy
    - jq --arg app_name "$SWING_WEB_IMAGE_NAME" '.containerDefinitions[0].image=$app_name' aws/Dockerrun.aws.json > aws/Dockerrun.aws.tmp.json
    - jq --arg app_name "$SWING_PROXY_IMAGE_NAME" '.containerDefinitions[1].image=$app_name' aws/Dockerrun.aws.tmp.json > Dockerrun.aws.json
  only:
    - staging
    - release
  dependencies:
    - docker-registry-web
    - docker-registry-proxy
  artifacts:
    paths:
      - Dockerrun.aws.json
    expire_in: 7 days
